/*============================================================================
                      TEMPLATE for LISTS of TYPE T
It implements STACKS whose elements are of type T. The atom of type T is
assumed to be printable `as it is'.
=========================================================================== */
#include  <iostream.h>
template<class T> class List
{struct cell
   {T atom; cell* next;
    cell(T at, cell* nx) : atom(at), next(nx) { };};
    cell* ptr;
public :
List(): ptr(NULL){}
void null() {ptr =NULL;}
bool isnull() {return (ptr == NULL);}

T head()
{if (ptr == NULL) {cout << "\nError: head of empty list \n";}
 else {return ptr->atom;}}

void tail()
{if (ptr == NULL) {cout << "\nError: tail of empty list \n";}
else {ptr=ptr->next;}}

void cons(T x) {ptr= new cell(x,ptr);}

void printlist()
{if (isnull()) {cout << "nil";}
 else {cout << head() << " "; //it works if head() is printable.
       cell* ptr1=ptr; ptr=ptr->next; printlist(); ptr=ptr1;}}
};   // end of template List<T>
//----------------------------------------------------------------------------
// Printing functions for different types of the elements of the list.
void iprintlist(List<int> L)   // printing integer lists
{if (L.isnull()) {cout << "intnil";}
 else {cout << L.head() << " ";
       L.tail(); iprintlist(L);}}

void bprintlist(List<bool> L)  // printing boolean lists
{if (L.isnull()) {cout << "boolnil";}
 else {cout << L.head() << " ";
       L.tail(); bprintlist(L);}};
//----------------------------------------------------------------------------
// The function append for lists of integers. It is NOT independent of the
// type of the elements.
List<int> append(List<int> list1, List<int> list2)
{if (list1.isnull()) {return list2;}
 else {int k=list1.head(); list1.tail();
 List<int> list12=(append(list1,list2));
 list12.cons(k); return list12;};}
//----------------------------------------------------------------------------
void main()
{List<int> list1; cout << "integer list1:\n";
list1.printlist(); cout << " = nil\n";
iprintlist(list1); cout << " = intnil\n";
int t0=84; int t1=144; list1.cons(84); list1.cons(143);
list1.cons(148); list1.printlist(); cout << " = 148 143 84 nil.\n";
list1.tail(); list1.printlist(); cout << " = 143 84 nil.\n";
list1.tail(); cout << list1.head() << " = 84\n";
list1.printlist(); cout << " = 84 nil\n";
iprintlist(append(list1,list1)); cout << " = 84 84 intnil\n";
list1.tail(); list1.printlist(); cout << " = nil";
cout << "\nhead of nil = " << list1.head();
//----------------------------------------------------------------------------
List<bool> list2; bool b2=true; bool b3=false; list2.cons(b2); list2.cons(b3);
cout << "\n------\n" << "boolean list2: \n0 1 boolnil = ";
bprintlist(list2); cout << "\n0 = " << list2.head(); cout << "\n";
}
/* input:   output:
------------------------------------------------------------------------------
            integer list1:
            nil = nil
            intnil = intnil
            148 143 84  nil = 148 143 84 nil.
            143 84  nil = 143 84 nil.
            84 = 84
            84  nil = 84 nil
            84 84  intnil = 84 84 intnil
            nil = nil
            Error: head of empty list

            head of nil = 134521832
            ------
            boolean list2:
            0 1 boolnil = 0 1  boolnil
            0 = 0
 -------------------------------------------------------------------------- */